## galax 1.1

=== Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.354 2008/02/21 21:41:21 simeon Exp $ #

#########################################################################
# Author:	Christopher A. Rath (AT&T Labs Research)
# Descripton:
#		This is a replacement Makefile for Galax that relies on the output
#		of a configuration script.  It is an attempt to clean up the
#		existing build process and make it more amenable to packaging
#		systems like GODI.
# History:
#	$Log: Makefile,v $
#	Revision 1.354  2008/02/21 21:41:21  simeon
#	February 21, 2008 - Jerome
#	
#	  o Debian:
#	     - Folded in Stefano's patches.
#	
#	  o Documentation:
#	     - Re-enabled documentation generation.
#	     - Fixed some formatting issues.
#	
#	Revision 1.353  2007/09/27 19:19:28  simeon
#	September 20, 2007 - Jerome
#	
#	** Please run configure again due to changes to detect Camomile's version **
#	
#	  o Galax Compilation:
#	     - Fixes to ./configure to support camomile's version.
#	     - Upgraded to Ocaml 3.10
#	       (changes in compilation due to new camlp4)
#	     - Added support for Camomile 0.7.* on top of Camomile 0.6.
#	       (changes due to new library names)
#	     - Now forcing use of Netsys, coming with latest ocamlnet.
#	
#	  o Join optimization:
#	     - Another fix to the compiler, to properly clean-up selec
#	       clause for join detection.
#	
#	Revision 1.352  2007/08/09 20:21:22  simeon
#	August 9, 2007 - Jerome
#	
#	  o XQueryX:
#	    - Added support for module interfaces in xqueryx2xquery.
#	
#	  o Interfaces:
#	    - Fixed pretty-printing of module interfaces.
#	
#	  o Galax Compilation:
#	    - Added missing dependencies for some target executables to the Galax
#	      library.
#	
#	Revision 1.351  2007/08/01 18:06:30  simeon
#	August 1, 2007 - Jerome
#	
#	  o XQueryX: First-cut support for XQueryX with trivial embedding
#	    in Galax. It supports the following features:
#	
#	     (1) Compiling XQueryX to XQuery using a command line tool called
#	         xqueryx2xquery.
#	
#	     (2) Running XQueryX with galax-run with the flag '-syntax
#	         xqueryx'.
#	
#	     (3) Embedding XQueryX expressions directly within XQuery.
#	
#	  (1) and (2) work on whole modules, while (3) only works with
#	  expressions since it has to be integrated with the rest of the
#	  grammar.
#	
#	  o Processing model:
#	     - Fixed ugly bug in the way parse handlers were built. Now
#	       properly taking configuration into account.
#	
#	Revision 1.350  2007/07/31 17:34:08  simeon
#	July 31, 2007 - Jerome
#	
#	  o Parsing:
#	     - Fixed another lurking bug in the lexing of sequence types,
#	       transitioning to the wrong state... (Was tripped by e.g.,
#	       instance of or typeswitch inside a constructor).
#	
#	       [Replaced old hack by better working new hack...sigh
#	
#	        Queries to test:
#	        <a>{1 instance of item()}</a>
#	        <a>{1 instance of item()*}</a>
#	        <a>{1 instance of item()(::)*}</a>
#	        every $a as item()* in (1, 2), $b as item()* in $a satisfies $b]
#	
#	  o Prolog:
#	     - Fixed another lurking bug in cyclic variable dependency
#	       checking (not clearing up the previous variable table in
#	       parallel branches of the dependency graph).
#	
#	  o XQueryX Trivial Embedding:
#	     - Started prepare for it. Added hook in normalization.
#	
#	Revision 1.349  2007/07/23 18:15:19  ndonose
#	fixed makefile options for zerod
#	
#	Revision 1.348  2007/07/21 17:46:07  ndonose
#	July 21, 2007 - Nicola
#	
#	  o Workflows:
#	    First version of an HTTP server providing an interface for
#	    ProjectZero workflows and acting as proxy towards the DXQ
#	    server running the workflow script.
#	    The current version does not support yet receive activities
#	    that are not enabled from the beginning.
#	
#	Revision 1.347  2007/07/18 16:54:18  simeon
#	July 18, 2007 - Jerome
#	
#	  Feature Galax
#	  Minimal Conformance	          14528 / 96 / 14637  (99.3%)
#	  Optional Features
#	    Schema Import Feature	  0   	/ 0   / 174
#	    Schema Validation Feature	  0   	/ 0   / 25
#	    Static Typing Feature	  46  	/ 0   / 46
#	    Full Axis Feature	 	  130 	/ 0   / 130
#	    Module Feature	 	  0 	/ 0   / 32
#	    Trivial XML Embedding Feature 0 	/ 0   / 4
#	
#	  o WSDL:
#	     - Removing wsdl_load.ml at cleanup-time, since it's being
#	       generated.
#	
#	  o Prolog:
#	     - Added check for cyclic definitions of global variable in
#	       modules.
#	
#	  o Testing:
#	     - Added group testing for the XQuery Appendices.
#	
#	Revision 1.346  2007/07/13 18:24:42  mff
#	July 13, 2007 - Mary
#	
#	   o Xquery_algebra_ast.mli + all files that depends on Algebra AST
#	     - Changes names of AST nodes for imported variables & functions.
#	       Conflated interfaces with imported
#	
#	   o Changed Pervasives _back_ to an XQuery module from an interface,
#	     because it really is a module whose functions are built-in.
#	     Sorry for churn on this.
#	
#	     - Removed stdlib/pervasive.xqi
#	     - Added glx:string_of_item
#	
#	   o Planio
#	     - Fixed bug in parsing of ElementKind and AttributeKind
#	
#	   o Code_execute
#	
#	     - Temporarily disabled optimization of Execute expressions to
#	       local server, which simply evaluate the remote expression
#	       locally, because there is an insidious bug when its called.
#	
#	   o Parse_xquery
#	     - Changed parsing of interfaces so that variables and functions
#	       are correctly tagged as coming from interfaces.  Previously,
#	       did this with an ugly hack in normalization.
#	
#	   o Galaxd & Galax_server
#	     - Added exception-handler argument to tcp_server and udp_server
#	       so that internal errors and async errors can be reported to the
#	       Gui.
#	
#	Revision 1.345  2007/06/28 15:17:30  ndonose
#	June 28, 2007 - Nicola
#	
#	  o WSDL: Updated the WSDL parser to make it work again with the
#	    latest changes in Galax.
#	
#	  o Removed wsdl_load.ml from the repository, as it is supposed to
#	    be generated from wsdl_load.mlp
#	
#	Revision 1.344  2007/05/16 15:32:07  mff
#	
#	
#	May 16, 2007 - Mary
#	
#	  MODULES and INTERFACES
#	  *** PLEASE READ THE WHOLE MESSAGE ***
#	
#	  o Deep changes to support separate module interfaces and module
#	    implementations.
#	
#	    - Compilation/evaluation now occur within context of a "compiled
#	      program".  (In new module code_selection/Compiled_program_units)
#	
#	      A compiled program consists of imported module interfaces,
#	      imported library modules, and an optional main module.
#	
#	    - All program units (statements,prologs,modules) are compiled in
#	      context of a compiled_program unit.
#	
#	    - New pre-processing phase (before normalization), computes
#	      transitive closure of imported library modules.  Used to
#	      populate compiled_program unit.
#	
#	    - Recursive module imports (as per standard) are prohibited.
#	
#	   o Changes to ASTs:
#	
#	     We distinguish between "external" functions/vars (which are
#	     defined in external programming environment) from "imported"
#	     functions/vars (which are defined in imported XQuery modules)
#	
#	     New kinds of declarations:
#	     Xquery_ast : EFunctionInterface and EVarInterface
#	     Xquery_core_ast : CEFunctionInterface and CEVarInterface
#	     Xquery_algebra_ast : AOEFunctionInterface and AOEVarDeclInterface
#	
#	   o Importing interfaces and modules
#	
#	     Module interfaces are imported during normalization.  Variable
#	     and function declarations in the Core rep of the imported
#	     interface are merged into the Core rep of the importing module.
#	
#	     If a module does not have an interface, an interface is created
#	     for it during the pre-processing stage.
#	
#	   o New interface stdlib/pervasive.xqi replaces stdlib/pervasive.xq
#	
#	     - Removed stdlib/pervasive.xq
#	     - NB: new file suffix ".xqi" for module interfaces.
#	
#	   o Code selection
#	
#	     References to imported variables and functions are resolved
#	     during code selection of the importing module.
#	
#	     The code_selection_context for a module points to the
#	     code_selection_contexts of the modules that it imports to resolve
#	     references to imported variables/functions.
#	
#	   o What works:
#	
#	     - Usecase, XQuery testsuite, and Galax regressions all pass
#	
#	   o What doesn't work:
#	
#	     - examples/caml_api/test.ml
#	     - C or Java APIs
#	     - Any DXQ program
#	
#	   o TODO:
#	
#	     - Physical types for external and imported variables: Right now,
#	     they are completely materialized XML values.
#	
#	Revision 1.343  2007/05/02 19:14:08  mff
#	
#	Targets for buildbot regressions
#	
#	Revision 1.342  2007/05/01 21:03:06  mff
#	
#	fast-regression added to Makefile
#	
#	Revision 1.341  2007/05/01 20:32:24  mff
#	
#	Added usecases: target for automated testing
#	
#	Revision 1.340  2007/03/21 15:52:52  mff
#	March 21, 2007 - Mary
#	
#	  o Galax_server:
#	    - Removed log of query-response size that was growing without
#	      bound!
#	    - Drip, drip, drip: other small memory leaks abound...
#	
#	Revision 1.339  2007/02/12 21:15:33  simeon
#	February 12, 2007 - Jerome
#	
#	  o Code clean up:
#	     - Removed obsolete modules: Factorize_update, Factorize_util.
#	
#	  o Galax Test Suite:
#	     - Added a first version of the Galax test suite in the CVS
#	       repository. This currently contains a few tests for: plan
#	       stability of the use cases, and join detection tests.
#	
#	  o Testing:
#	     - Finalized support for comparing query plans in the test
#	       harness.
#	     - Added an option to automatically generate expected results in
#	       case the file for that expected result is missing.
#	
#	       Usage: [galax-test -generate-results] to generate results.
#	
#	  o Toplevel:
#	     - Added three plan conversion utilities for convenience.
#	        [xquery2plan] generates a plan from an XQuery. **
#	        [xquery2xmlplan] generates an XML plan from an XQuery.
#	        [xmlplan2plan] generates a plan from an XML plan.
#	
#	      **you can turn optimization on by writing -optimization on.
#	
#	  o Updates/Parsing:
#	     - Removed 'snap delete' etc. variants for the update
#	       operations. Fixing shift/reduce conflicts. (e.g., WITH could
#	       parse as either a do replace or a snap replace).
#	
#	       The changes are:
#	         MapFromItem[$x]{P1}(P2) --> Map{P1}(P2) where occurrence of $x
#	         in P1 is turned into ID.
#	         MapToItem{P1}(P2) --> Map{P1}(P2)
#	         INPUT --> ID
#	         snap { P } --> Snap(P), same for Delete,Replace,Insert,Rename.
#	
#	  o Pretty printer:
#	     - Fixed the algebraic pretty-printer to align with the current
#	       formalization of the algebra [Ghelli,Onose,Rose,Simeon].
#	
#	  o Compiler:
#	     - Consolidated name creation (variables, tuple fields, etc.)
#	       throughout the compiler. This is now handled by a proper module
#	       [Namespace_generate]. This is important notably for the
#	       regression tests to ensure stability of variable names accross
#	       separate sets of compilation.
#	
#	Revision 1.338  2007/02/01 22:08:45  simeon
#	February 1, 2007 - Jerome
#	
#	  o Code cleanup:
#	     - Cleaned up all the source file headers. Added module

=== doc/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                             XML Query Engine                          #
#                             Regression Tests                          #
#                                                                       #
#########################################################################

#########################################################################
# Author:	Christopher A. Rath (AT&T Labs Research)
# Descripton:
#		This is a replacement Makefile for the Galax documentation
# History:
#	$Log: Makefile,v $
#	Revision 1.21  2008/03/13 17:59:40  mff
#	Re-made doc for release
#	
#	Revision 1.20  2008/03/12 22:30:58  simeon
#	March 12, 2008 - Jerome
#	
#	  o Installation:
#	     - Now installing the extensions examples directory.
#	     - Added missing META.in.
#	
#	  o Serialization:
#	     - Fixed a few issues with serialization (showing up while doing
#	       the tutorial).
#	
#	  o Documentation:
#	     - Added table of contents back.
#	     - Pass on installation chapter. Added section on how to run the
#	       W3C XQuery test suite.
#	     - Removed the 'accessing and storing XML' part relating to Jungle
#	       and datamodel, empty or obsolete.
#	     - Added back chapter on APIs.
#	     - Shuffled the chapters in the reference part (alignment is
#	       renamed conformance and comes first, 'general' last).
#	     - Removed tutorial part on serialization as well-formed,
#	       buggy. Added text for more useful 'standard' mode.
#	     - Pass on tutorial chapter added a short tutorial section on
#	       printing compilation phases.
#	
#	  o Testing:
#	     - Fixed the default config file to not point to the
#	       Galax-specific test suite. (for distribution).
#	
#	Revision 1.19  2008/02/21 21:41:21  simeon
#	February 21, 2008 - Jerome
#	
#	  o Debian:
#	     - Folded in Stefano's patches.
#	
#	  o Documentation:
#	     - Re-enabled documentation generation.
#	     - Fixed some formatting issues.
#	
#	Revision 1.18  2007/10/25 00:08:41  mff
#	***** Tagged with galax-0-9-9 for Debian Release to Stefano Zacchiroli <zack@bononia.it> *****
#	
#	October 24, 2007 - Mary
#	
#	  o Documentation:
#	
#	    Woefully incomplete vis a vis Updates, XQueryP, APIs, etc.
#	
#	  o Code_selection:
#	
#	    Fixed insidious bug in code selection for references to imported
#	    variable or imported function: Incorrectly returned
#	    code-selection-context of imported module instead of importing
#	    module.
#	
#	  o configure script
#	
#	    Disabled C and Java APIs until we figure out what we want to do
#	    with them.
#	
#	  o OCaml API examples
#	
#	    Aligned with new processing model
#	
#	Revision 1.17  2007/07/05 08:35:53  simeon
#	July 5, 2007 - Jerome
#	
#	  o Normalization:
#	     - Fixed normalization of function calls whose expected type is
#	       xs:anyURI (wrongly casting to xs:string).
#	
#	  o Optimization:
#	     - Added clean-up optimization rule for inverse MapFrom/MapTo:
#	         Map{#x}(Map{[x:ID]}(Op)) == Op
#	
#	Revision 1.16  2007/02/28 18:48:06  mff
#	
#	February 28, 2007 - Mary (DXQ)
#	
#	  o Clean-up of Galax Server code
#	
#	    - New module Galax_server_util:
#	
#	      Factorized functionality shared by Galax_server, Galaxd, and
#	      Webgui into Galax_server_util.  Contains:
#	        * Server UDP defaults
#	        * Server-name management (maps from virtual to actual names)
#	        * Shared GUI utilities
#	
#	    - Moved file and directory management utilities into Gmisc.
#	
#	    - Moved DXQ options into Top_options.
#	
#	    - Processing_context contains "short" hostname and port of server.
#	
#	Revision 1.15  2006/08/16 20:30:08  simeon
#	August 16, 2006 - Jerome
#	
#	  o Release:
#	    - Set the version number to 0.6.8.
#	    - Added 0.6.8 entries in the documentation and Web sites.
#	    - Some minor fixes the documentation, notably updating the
#	      contributor's list.
#	    - Added some text for support for ULTF, XQueryP in the release
#	      notes.
#	    - Fixed the ns_usecase expected result to match the one generated
#	      by Galax. Namespace handling in constructors may be fixed at
#	      some point and result in subsequent changes.
#	    - Fixed usecase Makefile to not set monitoring on.
#	  o ULTF/XQuery!/XQueryP Trilogy:
#	    - Added -language ultf option for W3C Update Facility.
#	    - Added minimalistic tutorial in the documentation for how to run
#	      those.
#	    - Added examples in ./examples/extensions for each of the 3
#	      languages.
#	  o F&O:
#	    - Fixed fn:matches function to not take optional second and third
#	      arguments anymore.
#	
#	Revision 1.14  2006/05/25 16:23:42  mff
#	
#	May 25, 2006 - Mary
#	
#	  o Added implementation(s) for fs:item-sequence-to-node-sequence on
#	    DOM tree & XML-token cursors.
#	
#	    This function is only necessary for typing purposes, but if
#	    rewriting is off, it must be implemented as the identity function
#	    on both DOM trees and XML-token cursors.
#	
#	  o galax-parse command-line options:
#	
#	    -dm       => All phases through loading
#	    -validate => All phases through validation
#	
#	  o Documentation - some updates
#	
#	Revision 1.13  2006/05/15 15:20:36  car
#	May 15, 2006 - Chris Rath
#	  o Added a new target, "byte" to the toplevel and subordinate Makefiles.
#	    - Only creates the byte-code galax library and byte-code toplevel applications.
#	  o Added a new target "byteworld" that works like "make world"
#		 - Only creates the byte-code galax library and byte-code toplevel applications.
#	
#	Revision 1.12  2006/05/12 18:15:00  car
#	May 12, 2006 - Chris Rath
#	  o Fixed missing files and typos in Makefile.galax
#	  o Added "regression" target to top level Makefile.
#	  o Removed regress/testconfig.xml from CVS; this file is now generated from testconfig-tmpl.xml
#	  o Updated all lower-level Makefiles to ensure they all have the standard targets
#	
#	Revision 1.11  2006/04/17 18:10:40  car
#	April 17, 2006 - Chris Rath
#	  o Changes necessary to align with GODI
#	
#########################################################################

#########################################################################
# Section:	Default target
# Description:
#		The default target for this Makefile is "all"
#########################################################################

default:	all

#########################################################################
# Section:	Makefile pre-includes
# Description:
#		This is where the file(s) generated during by the Configure script
#		are included.  If config/Makefile.conf does not exist, the
#		make will fail.
#
#		Makefile.galax:	Variables defined for compiling and linking Galax
#								applications in the build environment
#########################################################################
LOCALPREFIX=..

include $(LOCALPREFIX)/config/Makefile.galax
include $(LOCALPREFIX)/website/Makefile.config

#########################################################################
# Section:	Local variables
# Description:
#		These variables are used for targets of this Makefile
###########################################################################
SOURCES=general.tex commandline.tex alignment.tex readme.tex install.tex \
release_notes.tex api.tex developers.tex license.tex tutorial.tex

HTMLFILES=\
alignment.html \
api.html \
commandline.html \
developers.html \
general.html \
index.html \
install.html \
manual001.html \
manual.css \
manual.html \
readme.html \
release_notes.html \
tutorial.html
#documents.html \


#########################################################################
# Section:  Main targets
# Description:
#     This is where all of the named toplevel targets are placed.
#
#  all:        This target builds the regression targets
#  install::   This target does installation for C API files
#  uninstall:: This target uninstalls C API files
#  clean::     This target cleans files created in the all section
#########################################################################

#all:
all: manual.html

byte:

install: $(CONF_GALAX_MAN)
	$(CP) manual.pdf $(CONF_GALAX_MAN)
	for i in $(HTMLFILES); do ($(CP) $$i $(CONF_GALAX_MAN)); done
	for i in *.gif; do ($(CP) $$i $(CONF_GALAX_MAN)); done

install-website: $(CONF_GALAX_MAN)
	for i in $(HTMLFILES); do ($(CP) $$i $(WEBSITE)/doc); done
	for i in *.gif; do ($(CP) $$i $(WEBSITE)/doc); done

uninstall:
	$(RM) $(CONF_GALAX_MAN)/manual.pdf
	for i in $(HTMLFILES); do ($(RM) $(CONF_GALAX_MAN)/$$i); done
	for i in *.gif; do ($(RM) $(CONF_GALAX_MAN)/$$i); done

clean: 
	$(RM) manual.log manual.pdf *.aux *.haux *.htoc *.html

clobber::

realclean: clean
	$(RM) *.html manual.pdf

#########################################################################
# Sub-Section:  Secondary targets
# Description:
#     These are the supporting targets for "all"
#########################################################################

manual.html:	manual.pdf 
	hevea -exec /bin/date manual.tex
	hacha manual.html

manual.pdf:	manual.tex $(SOURCES) 
	pdflatex manual.tex
	pdflatex manual.tex

#########################################################################
# Section:  Makefile post-includes
# Description:
#		There are currently no post-includes for this Makefile
#########################################################################

=== examples/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.20 2007/02/01 22:08:46 simeon Exp $ #

#########################################################################
# Author:   Christopher A. Rath (AT&T Labs Research)
# Descripton:
#     This is a replacement Makefile for the Galax examples subcomponents
# History:
#  $Log: Makefile,v $
#  Revision 1.20  2007/02/01 22:08:46  simeon
#  February 1, 2007 - Jerome
#
#    o Code cleanup:
#       - Cleaned up all the source file headers. Added module
#         descriptions when missing, as well as CVS Id.
#       - Removed obsolete modules: Optimization_rules_treepattern_old,
#         Factorize_sideeffects.
#
#    o AST Walker:
#       - Added support for a generic fold operation on the AST (useful
#         to compute a boolean property on the AST for instance).
#
#    o Normalization:
#       - Small fix to the normalization of comparisons to re-enable join
#         detection, not using let bindings for the comparator
#         anymore. [hack]
#
#    o Rewriting:
#       - Added a judgment to check for side-effects, removed
#         corresponding obsolete judgment in Factorization.
#       - Moved the snap removal rule from optimization to rewriting,
#         cleaning up the plans as early as possible.
#
#  Revision 1.19  2006/05/15 15:20:36  car
#  May 15, 2006 - Chris Rath
#    o Added a new target, "byte" to the toplevel and subordinate Makefiles.
#      - Only creates the byte-code galax library and byte-code toplevel applications.
#    o Added a new target "byteworld" that works like "make world"
#  	 - Only creates the byte-code galax library and byte-code toplevel applications.
#
#  Revision 1.18  2006/05/12 18:15:00  car
#  May 12, 2006 - Chris Rath
#    o Fixed missing files and typos in Makefile.galax
#    o Added "regression" target to top level Makefile.
#    o Removed regress/testconfig.xml from CVS; this file is now generated from testconfig-tmpl.xml
#    o Updated all lower-level Makefiles to ensure they all have the standard targets
#
#  Revision 1.17  2006/04/17 18:10:40  car
#  April 17, 2006 - Chris Rath
#    o Changes necessary to align with GODI
#
#########################################################################

#########################################################################
# Section:  Default target
# Description:
#     The default target for this Makefile is "all"
#########################################################################

default: all

#########################################################################
# Section:  Makefile pre-includes
# Description:
#     This is where the file(s) generated during by the Configure script
#     are included.  If config/Makefile.conf does not exist, the
#     make will fail.
#
#     Makefile.galax:   Variables defined for compiling and linking Galax
#                       applications in the build environment
#########################################################################
LOCALPREFIX=..

include $(LOCALPREFIX)/config/Makefile.galax

#########################################################################
# Section:  Main targets
# Description:
#     This is where all of the named toplevel targets are placed.
#
#  all:        This target builds the GALAX_CAPI_TARGETS
#  install::   This target does installation for C API files
#  uninstall:: This target uninstalls C API files
#  clean::     This target cleans files created in the all section
#########################################################################

all:
	for i in $(GALAX_EXAMPLE_DIRS); do (cd $$i ; $(MAKE) all); done

byte:
	for i in $(GALAX_EXAMPLE_DIRS); do (cd $$i ; $(MAKE) byte); done

install:
	for i in $(GALAX_EXAMPLE_DIRS); do (cd $$i ; $(MAKE) install); done

uninstall:
	for i in $(GALAX_EXAMPLE_DIRS); do (cd $$i ; $(MAKE) uninstall); done

clean:
	for i in $(GALAX_EXAMPLE_DIRS); do (cd $$i ; $(MAKE) clean); done

clobber::
	for i in $(GALAX_EXAMPLE_DIRS); do (cd $$i ; $(MAKE) clobber); done

#########################################################################
# Section:  Makefile post-includes
# Description:
#     This is where the dependency file is included and generated
#     We place the dependencies to make sure that various files
#     are generated before we need them.
#########################################################################

updatedepend::
	for i in $(GALAX_EXAMPLE_DIRS); do (cd $$i ; $(MAKE) updatedepend); done

=== galapi/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.22 2007/02/01 22:08:46 simeon Exp $ #

#########################################################################
# Author:   Christopher A. Rath (AT&T Labs Research)
# Descripton:
#     This is a replacement Makefile for the Galax API subcomponents.
# History:
#  $Log: Makefile,v $
#  Revision 1.22  2007/02/01 22:08:46  simeon
#  February 1, 2007 - Jerome
#
#    o Code cleanup:
#       - Cleaned up all the source file headers. Added module
#         descriptions when missing, as well as CVS Id.
#       - Removed obsolete modules: Optimization_rules_treepattern_old,
#         Factorize_sideeffects.
#
#    o AST Walker:
#       - Added support for a generic fold operation on the AST (useful
#         to compute a boolean property on the AST for instance).
#
#    o Normalization:
#       - Small fix to the normalization of comparisons to re-enable join
#         detection, not using let bindings for the comparator
#         anymore. [hack]
#
#    o Rewriting:
#       - Added a judgment to check for side-effects, removed
#         corresponding obsolete judgment in Factorization.
#       - Moved the snap removal rule from optimization to rewriting,
#         cleaning up the plans as early as possible.
#
#  Revision 1.21  2006/05/15 15:20:36  car
#  May 15, 2006 - Chris Rath
#    o Added a new target, "byte" to the toplevel and subordinate Makefiles.
#      - Only creates the byte-code galax library and byte-code toplevel applications.
#    o Added a new target "byteworld" that works like "make world"
#  	 - Only creates the byte-code galax library and byte-code toplevel applications.
#
#  Revision 1.20  2006/05/12 18:15:00  car
#  May 12, 2006 - Chris Rath
#    o Fixed missing files and typos in Makefile.galax
#    o Added "regression" target to top level Makefile.
#    o Removed regress/testconfig.xml from CVS; this file is now generated from testconfig-tmpl.xml
#    o Updated all lower-level Makefiles to ensure they all have the standard targets
#
#  Revision 1.19  2006/04/17 18:10:40  car
#  April 17, 2006 - Chris Rath
#    o Changes necessary to align with GODI
#
#########################################################################

#########################################################################
# Section:  Default target
# Description:
#     The default target for this Makefile is "all"
#########################################################################

default: all

#########################################################################
# Section:  Makefile pre-includes
# Description:
#     This is where the file(s) generated during by the Configure script
#     are included.  If config/Makefile.conf does not exist, the
#     make will fail.
#
#     Makefile.galax:   Variables defined for compiling and linking Galax
#                       applications in the build environment
#########################################################################
LOCALPREFIX=..

include ../config/Makefile.galax

#########################################################################
# Section:  Main targets
# Description:
#     This is where all of the named toplevel targets are placed.
#
#  all:        This target builds the configured API targets
#  install::   This target does installation for configured API targets
#  uninstall:: This target uninstalls configured API targets
#  clean::     This target cleans files created in the all section
#########################################################################

all:
	for i in $(GALAX_APIS); do (cd $$i ; $(MAKE) all); done

byte:
	for i in $(GALAX_APIS); do (cd $$i ; $(MAKE) byte); done

clean:
	for i in $(GALAX_APIS); do (cd $$i ; $(MAKE) clean); done

install:
	for i in $(GALAX_APIS); do (cd $$i ; $(MAKE) install); done

uninstall:
	for i in $(GALAX_APIS); do (cd $$i ; $(MAKE) uninstall); done

clobber::
	for i in $(GALAX_APIS); do (cd $$i ; $(MAKE) clobber); done

#########################################################################
# Section:  Makefile post-includes
# Description:
#		There are currently no post-includes for this Makefile
#########################################################################

updatedepend::
	for i in $(GALAX_APIS); do (cd $$i ; $(MAKE) updatedepend); done

=== regress/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.57 2007/05/02 20:27:20 mff Exp $ #

#########################################################################
# Author:	Christopher A. Rath (AT&T Labs Research)
# Descripton:
#		This is a replacement Makefile for the Galax regression suite
# History:
#	$Log: Makefile,v $
#	Revision 1.57  2007/05/02 20:27:20  mff
#	
#	More buildbot testing
#	
#	Revision 1.56  2007/05/02 19:59:18  mff
#	
#	BuildBot TEST steps
#	
#	Revision 1.55  2007/05/02 19:14:08  mff
#	
#	Targets for buildbot regressions
#	
#	Revision 1.54  2007/02/12 21:15:33  simeon
#	February 12, 2007 - Jerome
#	
#	  o Code clean up:
#	     - Removed obsolete modules: Factorize_update, Factorize_util.
#	
#	  o Galax Test Suite:
#	     - Added a first version of the Galax test suite in the CVS
#	       repository. This currently contains a few tests for: plan
#	       stability of the use cases, and join detection tests.
#	
#	  o Testing:
#	     - Finalized support for comparing query plans in the test
#	       harness.
#	     - Added an option to automatically generate expected results in
#	       case the file for that expected result is missing.
#	
#	       Usage: [galax-test -generate-results] to generate results.
#	
#	  o Toplevel:
#	     - Added three plan conversion utilities for convenience.
#	        [xquery2plan] generates a plan from an XQuery. **
#	        [xquery2xmlplan] generates an XML plan from an XQuery.
#	        [xmlplan2plan] generates a plan from an XML plan.
#	
#	      **you can turn optimization on by writing -optimization on.
#	
#	  o Updates/Parsing:
#	     - Removed 'snap delete' etc. variants for the update
#	       operations. Fixing shift/reduce conflicts. (e.g., WITH could
#	       parse as either a do replace or a snap replace).
#	
#	       The changes are:
#	         MapFromItem[$x]{P1}(P2) --> Map{P1}(P2) where occurrence of $x
#	         in P1 is turned into ID.
#	         MapToItem{P1}(P2) --> Map{P1}(P2)
#	         INPUT --> ID
#	         snap { P } --> Snap(P), same for Delete,Replace,Insert,Rename.
#	
#	  o Pretty printer:
#	     - Fixed the algebraic pretty-printer to align with the current
#	       formalization of the algebra [Ghelli,Onose,Rose,Simeon].
#	
#	  o Compiler:
#	     - Consolidated name creation (variables, tuple fields, etc.)
#	       throughout the compiler. This is now handled by a proper module
#	       [Namespace_generate]. This is important notably for the
#	       regression tests to ensure stability of variable names accross
#	       separate sets of compilation.
#	
#	Revision 1.53  2007/02/01 22:08:53  simeon
#	February 1, 2007 - Jerome
#	
#	  o Code cleanup:
#	     - Cleaned up all the source file headers. Added module
#	       descriptions when missing, as well as CVS Id.
#	     - Removed obsolete modules: Optimization_rules_treepattern_old,
#	       Factorize_sideeffects.
#	
#	  o AST Walker:
#	     - Added support for a generic fold operation on the AST (useful
#	       to compute a boolean property on the AST for instance).
#	
#	  o Normalization:
#	     - Small fix to the normalization of comparisons to re-enable join
#	       detection, not using let bindings for the comparator
#	       anymore. [hack]
#	
#	  o Rewriting:
#	     - Added a judgment to check for side-effects, removed
#	       corresponding obsolete judgment in Factorization.
#	     - Moved the snap removal rule from optimization to rewriting,
#	       cleaning up the plans as early as possible.
#	
#	Revision 1.52  2006/12/14 04:53:20  simeon
#	December 13, 2006 - Jerome
#	
#	  Current testing results on XQTS 1.0.2:
#	
#	  Feature Galax
#	  Minimal Conformance	          14497 / 114 / 14637  (99.1%)
#	  Optional Features
#	    Schema Import Feature	  0   	/ 0   / 174
#	    Schema Validation Feature	  0   	/ 0   / 25
#	    Static Typing Feature	  46  	/ 0   / 46
#	    Full Axis Feature	 	  130 	/ 0   / 130
#	    Module Feature	 	  0 	/ 0   / 32
#	    Trivial XML Embedding Feature 0 	/ 0   / 4
#	
#	  o Compilation:
#	     - Added support for separate -galax-regression option to indicate
#	       where the Galax Test Suite is installed.
#	     - Fixed circular dependency in optimization walker/judge modules,
#	       resulting from the latest reorg.
#	
#	  o Testing:
#	     - Fixed support for multiple test units, generating distinct
#	       files instead of overriding them. Fixed printing for multiple
#	       test units.
#	     - Added support for comparison of query plans.
#	
#	  o Updates:
#	     - Fixed 'do rename' to properly handle xs:string and xs:untyped
#	       values for the name expression.
#	
#	  o F&O:
#	     - Fixed fn:dateTime to support empty sequence parameters.
#	
#	  o Pragmas:
#	     - Now properly resolving Pragmas QNames.
#	     - Fixed serious parsing and lexing issues with pragmas (wrong
#	       lexical state created in some cases).
#	     - Fixed bug, now raising an error when there is no expression.
#	     - Added check that the pragma QName and content is separated by
#	       at least a whitespace character.
#	
#	  o Parsing:
#	
#	    Long over-due cleanup of the lexers. This fixes two major
#	    problems: (1) we now have keyword tables which makes for a more
#	    easily extensible parser, and smaller lexing tables.  (2) we don't
#	    rely on long keywords anymore which means we properly implement
#	    comments within keywords. [ Note that it's not completely true, we
#	    still have a few long keywords hanging around, notably those with
#	    QNames inside... This still need some work, but should get us
#	    going. ]
#	
#	     - Removing numerous unused lexing rules in some of the states,
#	       notably in the operator's state.
#	     - Moved part of the keywords used in prolog declarations from the
#	       operator's state to the declaration state.
#	     - Consolidated duplicated string literals and comments lexing
#	       rules to use the same lexer.
#	     - Added support for simple kind of look ahead in lexing handlers.
#	     - Added keyword tables for the operator, default, and namespace
#	       declaration states.
#	     - Removed (almost) all long keywords from the default,
#	       operators, and namespace declaration state.
#	     - Fixed bug, 'as' not recognized as a qname in the default state.
#	
#	Revision 1.51  2006/08/17 14:09:29  simeon
#	August 17, 2006 - Jerome
#	
#	  o Testing:
#	    - Added cleaner diff for expected vs. actual test results using
#	      XQuery.
#	
#	Revision 1.50  2006/08/16 19:55:52  mff
#	
#	Added reference test results to regress/
#	
#	Revision 1.49  2006/05/15 15:20:37  car
#	May 15, 2006 - Chris Rath
#	  o Added a new target, "byte" to the toplevel and subordinate Makefiles.
#	    - Only creates the byte-code galax library and byte-code toplevel applications.
#	  o Added a new target "byteworld" that works like "make world"
#		 - Only creates the byte-code galax library and byte-code toplevel applications.
#	
#	Revision 1.48  2006/05/12 18:15:01  car
#	May 12, 2006 - Chris Rath
#	  o Fixed missing files and typos in Makefile.galax
#	  o Added "regression" target to top level Makefile.
#	  o Removed regress/testconfig.xml from CVS; this file is now generated from testconfig-tmpl.xml
#	  o Updated all lower-level Makefiles to ensure they all have the standard targets
#	
#	Revision 1.47  2006/04/17 18:10:40  car
#	April 17, 2006 - Chris Rath
#	  o Changes necessary to align with GODI
#	
#########################################################################

#########################################################################
# Section:	Default target
# Description:
#		The default target for this Makefile is "all"
#########################################################################

default:	all

#########################################################################
# Section:	Makefile pre-includes
# Description:
#		This is where the file(s) generated during by the Configure script
#		are included.  If config/Makefile.conf does not exist, the
#		make will fail.
#
#		Makefile.galax:	Variables defined for compiling and linking Galax
#								applications in the build environment
#########################################################################
LOCALPREFIX=..

include $(LOCALPREFIX)/config/Makefile.galax

#########################################################################
# Section:  Main targets
# Description:
#     This is where all of the named toplevel targets are placed.
#
#  all:        This target builds the regression targets
#  install::   This target does installation for C API files
#  uninstall:: This target uninstalls C API files
#  clean::     This target cleans files created in the all section
#########################################################################

all: testconfig.xml

byte:

install: $(CONF_GALAX_REGRESS)
	$(SED) -e "s:XQUERYUNIT:$(CONF_XQUERYUNIT):" -e "s:GALAXUNIT:$(CONF_GALAXUNIT):" -e "s:REGRESS:$(CONF_GALAX_REGRESS):" testconfig-tmpl.xml > $(CONF_GALAX_REGRESS)/testconfig.xml
	$(CP) knownbugs.xml $(CONF_GALAX_REGRESS)
	$(SED) -e "s:CONF_GALAX_CONFIG:$(CONF_GALAX_CONFIG):g" Makefile-inst > $(CONF_GALAX_REGRESS)/Makefile
	$(CP) testresults-W3C-reference.xml  $(CONF_GALAX_REGRESS)
	$(CP) testresults-Galax-reference.xml  $(CONF_GALAX_REGRESS)
	$(CP) diff.xq  $(CONF_GALAX_REGRESS)

uninstall:
	$(RM) $(CONF_GALAX_REGRESS)/testconfig.xml
	$(RM) $(CONF_GALAX_REGRESS)/knownbugs.xml
	$(RM) $(CONF_GALAX_REGRESS)/Makefile

clean: 
	$(RM) testresults-W3C.xml
	$(RM) testresults-Galax.xml
	$(RM) buildbot.diffs

clobber::

#########################################################################
# Section:  Makefile post-includes
# Description:
#		There are currently no post-includes for this Makefile
#########################################################################

testconfig.xml:	testconfig-tmpl.xml
	$(SED) -e "s:XQUERYUNIT:$(CONF_XQUERYUNIT):" -e "s:GALAXUNIT:$(CONF_GALAXUNIT):" -e "s:REGRESS:$(CONF_PACKAGE_SRC)/regress:" testconfig-tmpl.xml > testconfig.xml

tests: testconfig.xml
	$(LOCALPREFIX)/galax-test$(EXE) testconfig.xml

tests-gen: testconfig.xml
	$(LOCALPREFIX)/galax-test$(EXE) -generate-results testconfig.xml

w3c-diff:
	echo ""
	echo "******************************************"
	echo "*** Tests which differ from expected run: "
	echo "******************************************"
	echo ""
	$(LOCALPREFIX)/galax-run -var unit=W3C diff.xq
	echo ""
	echo "******************************************"

galax-diff:
	echo ""
	echo "******************************************"
	echo "*** Tests which differ from expected run: "
	echo "******************************************"
	echo ""
	$(LOCALPREFIX)/galax-run -var unit=Galax diff.xq
	echo ""
	echo "******************************************"

silent-diff:
	if test -f testresults-W3C.xml; then $(MAKE) w3c-diff; fi
	if test -f testresults-Galax.xml; then $(MAKE) galax-diff; fi

buildbot-diff: tests
	if test -f testresults-W3C.xml; then $(LOCALPREFIX)/galax-run -var unit=W3C diff.xq > buildbot.diffs; fi
	if test -f testresults-Galax.xml; then $(LOCALPREFIX)/galax-run -var unit=Galax diff.xq	>> buildbot.diffs; fi
	(j=`grep -l diff buildbot.diffs`; if test -n "$$j"; then exit 1; fi)

diff:
	$(MAKE) -s silent-diff

=== tools/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.29 2007/02/01 22:08:54 simeon Exp $ #

#
# Makefile for pre-compilation tools
#

start:
	$(MAKE) smart

LOCALPREFIX=..
include $(LOCALPREFIX)/config/Makefile
include $(LOCALPREFIX)/config/Makefile.gen

.PHONY: jabber stemmer

smart:
	set -e; (for d in $(REQUIREDTOOLS); do ($(MAKE) $$d); done)
	set -e; (for d in $(REALTOOLS); do ($(MAKE) $$d); done)

#smart:
# 	$(MAKE) ucs2_to_utf8_galax
# 	$(MAKE) http_galax
# 	$(MAKE) glx_curl_galax
# 	$(MAKE) escaping_galax
# 	$(MAKE) unix2dos_galax

ucs2_to_utf8_galax:
	$(MAKE) -C ucs2_to_utf8 all

http_galax:
	$(MAKE) -C http smart

stemmer:
	$(MAKE) -C stemmer smart

curl:
	$(MAKE) -C glx_curl smart

jungle:
	$(MAKE) -C Jungle smart

apache:

escaping_galax:
	$(MAKE) -C escaping all

unix2dos_galax:
	$(MAKE) -C unix2dos all

jabber:
	$(MAKE) -C jabber smart

clean:
	$(MAKE) -C ucs2_to_utf8 clean
	$(MAKE) -C http clean
	$(MAKE) -C glx_curl clean
	$(MAKE) -C Jungle clean
	$(MAKE) -C escaping clean
	$(MAKE) -C unix2dos clean
	$(MAKE) -C jabber clean
	$(MAKE) -C stemmer clean

depend:
	$(MAKE) -C ucs2_to_utf8 depend
	$(MAKE) -C glx_curl depend
	$(MAKE) -C Jungle depend
	$(MAKE) -C stemmer depend

installucs2_to_utf8_galax:

installhttp_galax:
	cd http ; $(MAKE) install

installcurl:
	cd glx_curl ; $(MAKE) install

installjungle:
	cd Jungle ; $(MAKE) install

installstemmer:
	cd stemmer; $(MAKE) install

installescaping_galax:

installunix2dos_galax:


installjabber:
	cd jabber ; $(MAKE) install

installapache:

install:
	set -e; (for d in $(REALTOOLS); do ($(MAKE) install$$d); done)

=== usecases/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.68 2007/07/11 19:58:52 simeon Exp $ #

#########################################################################
# Author:	Christopher A. Rath (AT&T Labs Research)
# Descripton:
#		This is a replacement Makefile for the Galax usecases
# History:
#	$Log: Makefile,v $
#	Revision 1.68  2007/07/11 19:58:52  simeon
#	July 10, 2007 - Jerome
#	
#	  o Pretty-printer:
#	     - Fixed pretty-printer for blocks inside function declarations.
#	     - Fixed pretty-printer for fixed attributes in elements! [See
#	       Nicola's thread]
#	
#	Revision 1.67  2007/05/16 15:32:13  mff
#	
#	
#	May 16, 2007 - Mary
#	
#	  MODULES and INTERFACES
#	  *** PLEASE READ THE WHOLE MESSAGE ***
#	
#	  o Deep changes to support separate module interfaces and module
#	    implementations.
#	
#	    - Compilation/evaluation now occur within context of a "compiled
#	      program".  (In new module code_selection/Compiled_program_units)
#	
#	      A compiled program consists of imported module interfaces,
#	      imported library modules, and an optional main module.
#	
#	    - All program units (statements,prologs,modules) are compiled in
#	      context of a compiled_program unit.
#	
#	    - New pre-processing phase (before normalization), computes
#	      transitive closure of imported library modules.  Used to
#	      populate compiled_program unit.
#	
#	    - Recursive module imports (as per standard) are prohibited.
#	
#	   o Changes to ASTs:
#	
#	     We distinguish between "external" functions/vars (which are
#	     defined in external programming environment) from "imported"
#	     functions/vars (which are defined in imported XQuery modules)
#	
#	     New kinds of declarations:
#	     Xquery_ast : EFunctionInterface and EVarInterface
#	     Xquery_core_ast : CEFunctionInterface and CEVarInterface
#	     Xquery_algebra_ast : AOEFunctionInterface and AOEVarDeclInterface
#	
#	   o Importing interfaces and modules
#	
#	     Module interfaces are imported during normalization.  Variable
#	     and function declarations in the Core rep of the imported
#	     interface are merged into the Core rep of the importing module.
#	
#	     If a module does not have an interface, an interface is created
#	     for it during the pre-processing stage.
#	
#	   o New interface stdlib/pervasive.xqi replaces stdlib/pervasive.xq
#	
#	     - Removed stdlib/pervasive.xq
#	     - NB: new file suffix ".xqi" for module interfaces.
#	
#	   o Code selection
#	
#	     References to imported variables and functions are resolved
#	     during code selection of the importing module.
#	
#	     The code_selection_context for a module points to the
#	     code_selection_contexts of the modules that it imports to resolve
#	     references to imported variables/functions.
#	
#	   o What works:
#	
#	     - Usecase, XQuery testsuite, and Galax regressions all pass
#	
#	   o What doesn't work:
#	
#	     - examples/caml_api/test.ml
#	     - C or Java APIs
#	     - Any DXQ program
#	
#	   o TODO:
#	
#	     - Physical types for external and imported variables: Right now,
#	     they are completely materialized XML values.
#	
#	Revision 1.66  2007/05/02 20:27:20  mff
#	
#	More buildbot testing
#	
#	Revision 1.65  2007/05/02 19:59:18  mff
#	
#	BuildBot TEST steps
#	
#	Revision 1.64  2007/05/02 19:14:08  mff
#	
#	Targets for buildbot regressions
#	
#	Revision 1.63  2007/02/12 21:15:35  simeon
#	February 12, 2007 - Jerome
#	
#	  o Code clean up:
#	     - Removed obsolete modules: Factorize_update, Factorize_util.
#	
#	  o Galax Test Suite:
#	     - Added a first version of the Galax test suite in the CVS
#	       repository. This currently contains a few tests for: plan
#	       stability of the use cases, and join detection tests.
#	
#	  o Testing:
#	     - Finalized support for comparing query plans in the test
#	       harness.
#	     - Added an option to automatically generate expected results in
#	       case the file for that expected result is missing.
#	
#	       Usage: [galax-test -generate-results] to generate results.
#	
#	  o Toplevel:
#	     - Added three plan conversion utilities for convenience.
#	        [xquery2plan] generates a plan from an XQuery. **
#	        [xquery2xmlplan] generates an XML plan from an XQuery.
#	        [xmlplan2plan] generates a plan from an XML plan.
#	
#	      **you can turn optimization on by writing -optimization on.
#	
#	  o Updates/Parsing:
#	     - Removed 'snap delete' etc. variants for the update
#	       operations. Fixing shift/reduce conflicts. (e.g., WITH could
#	       parse as either a do replace or a snap replace).
#	
#	       The changes are:
#	         MapFromItem[$x]{P1}(P2) --> Map{P1}(P2) where occurrence of $x
#	         in P1 is turned into ID.
#	         MapToItem{P1}(P2) --> Map{P1}(P2)
#	         INPUT --> ID
#	         snap { P } --> Snap(P), same for Delete,Replace,Insert,Rename.
#	
#	  o Pretty printer:
#	     - Fixed the algebraic pretty-printer to align with the current
#	       formalization of the algebra [Ghelli,Onose,Rose,Simeon].
#	
#	  o Compiler:
#	     - Consolidated name creation (variables, tuple fields, etc.)
#	       throughout the compiler. This is now handled by a proper module
#	       [Namespace_generate]. This is important notably for the
#	       regression tests to ensure stability of variable names accross
#	       separate sets of compilation.
#	
#	Revision 1.62  2007/02/01 22:08:55  simeon
#	February 1, 2007 - Jerome
#	
#	  o Code cleanup:
#	     - Cleaned up all the source file headers. Added module
#	       descriptions when missing, as well as CVS Id.
#	     - Removed obsolete modules: Optimization_rules_treepattern_old,
#	       Factorize_sideeffects.
#	
#	  o AST Walker:
#	     - Added support for a generic fold operation on the AST (useful
#	       to compute a boolean property on the AST for instance).
#	
#	  o Normalization:
#	     - Small fix to the normalization of comparisons to re-enable join
#	       detection, not using let bindings for the comparator
#	       anymore. [hack]
#	
#	  o Rewriting:
#	     - Added a judgment to check for side-effects, removed
#	       corresponding obsolete judgment in Factorization.
#	     - Moved the snap removal rule from optimization to rewriting,
#	       cleaning up the plans as early as possible.
#	
#	Revision 1.61  2006/08/16 18:33:32  mff
#	August 16, 2006 - Mary
#	
#	  o Configure script
#	    - Sets $ocaml_home if not set by default
#	
#	  o Code_selection_context:
#	    - Added enter/exit_closure_context
#	
#	  o Cs_code_selection_top
#	    Galapi/galax
#	    Procmod_compiler
#	    Procmod_phases
#	    Procmod_types
#	
#	    Cs_code_selection_top.code_selection_statement now correctly
#	    returns updated code_selection_context.  Previously, it was
#	    dumped.
#	
#	    Corresponding changes in modules listed above to propagate and
#	    return updated code_selection_context.
#	
#	  o Cs_code_typing_top:
#	    type annotation of top-level expression stored as a global
#	    annotation so available to caller.
#	
#	  o Cs_util_coercion:
#	    Added missing coercion functions
#	
#	  o Code_binding:
#	    Tuple fields contain physical_xml_values, not physical_values:
#	    minor changes to support this change
#	
#	  o Code_execute:
#	    Added support for shipping plans that return tables/tuple-streams
#	
#	  o Code_util_materialize:
#	    Changed names of functions to reflect type of materialization,
#	    e.g., materialize_cursor_to_dom_value_array
#	
#	    Many files updated to reflect name change:
#	    code_group_order.ml
#	    code_hash_join.ml
#	    code_join.ml
#	    code_nestedloop.ml
#	    code_sort_join.ml
#	    code_tuple.ml
#	
#	  o Parse_xquery.mly:
#	    Fixed long-standing bug: EOF missing from end of library and main
#	    modules.
#	
#	  o Website/demo/querycgi.ml : alignment
#	
#	August 16, 2006 - Mary (DXQ)
#	
#	  o DNS examples:
#	    Changed name of module interface to dns.xqi
#	
#	  o Optimization_dxq:
#	    Working on DXQ opts
#	
#	  o Planio/*:
#	    Added support for serializing and parsing.
#	    ***All these files need to be reorganized.  They are a mess***
#	
#	  o Galax_server: fixed error-return XML
#	
#	  o Galaxd: yet another debug log bug
#	
#	Revision 1.60  2006/05/15 15:20:37  car
#	May 15, 2006 - Chris Rath
#	  o Added a new target, "byte" to the toplevel and subordinate Makefiles.
#	    - Only creates the byte-code galax library and byte-code toplevel applications.
#	  o Added a new target "byteworld" that works like "make world"
#		 - Only creates the byte-code galax library and byte-code toplevel applications.
#	
#	Revision 1.59  2006/05/12 18:15:01  car
#	May 12, 2006 - Chris Rath
#	  o Fixed missing files and typos in Makefile.galax
#	  o Added "regression" target to top level Makefile.
#	  o Removed regress/testconfig.xml from CVS; this file is now generated from testconfig-tmpl.xml
#	  o Updated all lower-level Makefiles to ensure they all have the standard targets
#	
#	Revision 1.58  2006/04/17 18:10:41  car
#	April 17, 2006 - Chris Rath
#	  o Changes necessary to align with GODI
#	
#########################################################################

#########################################################################
# Section:	Default target
# Description:
#		The default target for this Makefile is "all"
#########################################################################

default:	all

#########################################################################
# Section:	Makefile pre-includes
# Description:
#		This is where the file(s) generated during by the Configure script
#		are included.  If config/Makefile.conf does not exist, the
#		make will fail.
#
#		Makefile.galax:	Variables defined for compiling and linking Galax
#								applications in the build environment
#########################################################################
LOCALPREFIX=..

include $(LOCALPREFIX)/config/Makefile.galax

#########################################################################
# Section:	Local variables
# Description:
#		These variables are used for targets of this Makefile
###########################################################################

BINDIR=..
TYPE_KIND=weak
USECASES= ns parts rel seq sgml string tree xmp

ifdef OCAMLOPT
BINEXT=$(OPT)
else
BINEXT=$(BYTE)
endif

DOCFILES=\
auction.xml \
bids.xml \
book1.xml \
books.xml \
company-data.xml \
company.dtd \
herpo.xsd \
hispo.xsd \
items.xml \
parts.xml \
prices.xml \
report1.xml \
sgml.xml \
string.xml \
users.xml \
xmark.0.xml \
xmark.xml \
xmpbib.xml \
xmpreviews.xml

#########################################################################
# Section:  Main targets
# Description:
#     This is where all of the named toplevel targets are placed.
#
#  all:        This target does nothing in the build environment
#  install::   This target does installation for the usecases
#  uninstall:: This target uninstalls the usecases
#  clean::     This target cleans files created in the all section
#########################################################################

all:

byte:

install: $(CONF_GALAX_USECASES) $(CONF_GALAX_USECASES)/docs
	$(SED) -e "s:CONF_GALAX_CONFIG:$(CONF_GALAX_CONFIG):" Makefile-inst > $(CONF_GALAX_USECASES)/Makefile

=== website/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.25 2008/03/12 22:30:58 simeon Exp $ #

# Web demo Makefile

start:
	$(MAKE) world

LOCALPREFIX=..
include $(LOCALPREFIX)/config/Makefile.galax

include Makefile.config


###########################################################################
# You should not need to modify below this line

world: 
	$(MAKE) opt

opt: 
	(cd demo; $(MAKE) opt)

install: 
	$(MAKE) install-front
	$(MAKE) install-demo
	$(MAKE) install-documentation
	chmod -R a+r $(WEBSITE)

install-documentation:
	if test -d $(WEBSITE)/doc; then : ; else $(MKDIR) $(WEBSITE)/doc; fi
	(cd ../doc; $(MAKE) install-website)

install-demo:
	(cd demo; $(MAKE) installopt)

install-front:
	if test -d $(WEBSITE); then : ; else $(MKDIR) $(WEBSITE); fi
	if test -d $(DEMOSITE); then : ; else $(MKDIR) $(DEMOSITE); fi
	if test -d $(DEMOCGIBIN); then : ; else $(MKDIR) $(DEMOCGIBIN); fi
	cp *.html $(WEBSITE)
	if test -d $(WEBSITE)/doc; then : ; else $(MKDIR) $(WEBSITE)/doc; fi
	cp $(CONF_GALAX_MAN)/*.html $(WEBSITE)/doc
	cp $(CONF_GALAX_MAN)/*.gif $(WEBSITE)/doc
	cp $(CONF_GALAX_MAN)/manual.pdf $(WEBSITE)/doc
	cp *.css $(WEBSITE)
	cp ../LICENSE $(WEBSITE)
	cp -r images $(WEBSITE)
	cp -r optimization $(WEBSITE)
	chmod a+x $(WEBSITE)/images
	chmod a+x $(WEBSITE)/optimization

#	chmod a+x $(WEBSITE)/slides
#	cp -r slides $(WEBSITE)

clean:
	(cd demo; $(MAKE) clean)

=== examples/c_api/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.42 2007/07/05 08:35:54 simeon Exp $ #

#########################################################################
# Author:	Christopher A. Rath (AT&T Labs Research)
# Descripton:
#		This is a replacement Makefile for the Galax C API examples
# History:
#	$Log: Makefile,v $
#	Revision 1.42  2007/07/05 08:35:54  simeon
#	July 5, 2007 - Jerome
#	
#	  o Normalization:
#	     - Fixed normalization of function calls whose expected type is
#	       xs:anyURI (wrongly casting to xs:string).
#	
#	  o Optimization:
#	     - Added clean-up optimization rule for inverse MapFrom/MapTo:
#	         Map{#x}(Map{[x:ID]}(Op)) == Op
#	
#	Revision 1.41  2007/02/01 22:08:46  simeon
#	February 1, 2007 - Jerome
#	
#	  o Code cleanup:
#	     - Cleaned up all the source file headers. Added module
#	       descriptions when missing, as well as CVS Id.
#	     - Removed obsolete modules: Optimization_rules_treepattern_old,
#	       Factorize_sideeffects.
#	
#	  o AST Walker:
#	     - Added support for a generic fold operation on the AST (useful
#	       to compute a boolean property on the AST for instance).
#	
#	  o Normalization:
#	     - Small fix to the normalization of comparisons to re-enable join
#	       detection, not using let bindings for the comparator
#	       anymore. [hack]
#	
#	  o Rewriting:
#	     - Added a judgment to check for side-effects, removed
#	       corresponding obsolete judgment in Factorization.
#	     - Moved the snap removal rule from optimization to rewriting,
#	       cleaning up the plans as early as possible.
#	
#	Revision 1.40  2006/05/15 15:20:36  car
#	May 15, 2006 - Chris Rath
#	  o Added a new target, "byte" to the toplevel and subordinate Makefiles.
#	    - Only creates the byte-code galax library and byte-code toplevel applications.
#	  o Added a new target "byteworld" that works like "make world"
#		 - Only creates the byte-code galax library and byte-code toplevel applications.
#	
#	Revision 1.39  2006/05/12 18:15:00  car
#	May 12, 2006 - Chris Rath
#	  o Fixed missing files and typos in Makefile.galax
#	  o Added "regression" target to top level Makefile.
#	  o Removed regress/testconfig.xml from CVS; this file is now generated from testconfig-tmpl.xml
#	  o Updated all lower-level Makefiles to ensure they all have the standard targets
#	
#	Revision 1.38  2006/04/17 18:10:40  car
#	April 17, 2006 - Chris Rath
#	  o Changes necessary to align with GODI
#	
#########################################################################

#########################################################################
# Section:	Default target
# Description:
#		The default target for this Makefile is "all"
#########################################################################
default: all

#########################################################################
# Section:	Makefile pre-includes
# Description:
#		This is where the file(s) generated during by the Configure script
#		are included.  If config/Makefile.conf does not exist, the
#		make will fail.
#
#		Makefile.galax:	Variables defined for compiling and linking Galax
#								applications in the build environment
#########################################################################
LOCALPREFIX=../..

include $(LOCALPREFIX)/config/Makefile.galax

#########################################################################
# Section:	Local variables
# Description:
#		These variables are used for targets of this Makefile
###########################################################################

EXAMPLE=example
EXAMPLEOBJECT=$(EXAMPLE).o

TEST1=test
TEST1OBJECT=$(TEST1).o

#########################################################################
# Sub-Section:	C compilation variables and rules
# Description:
#		These are the variables and rules for building C object files
###########################################################################
.c.o:
	$(CC) $(CFLAGS) $(CCFLAGS) $(GALAX_CAPI_INCLUDES) -c $<

#########################################################################
# Sub-Section:	Targets
# Description:
#		These are the configuration-dependent targets built by "all"
###########################################################################
ALL_PROGRAMS=$(EXAMPLE)$(EXE) $(TEST1)$(EXE)
ALL_OBJECTS=$(EXAMPLEOBJECT) $(TEST1OBJECT)
ALL_SOURCE=$(ALL_OBJECTS:.o=.c)
ALL_EXPECT=$(ALL_OBJECTS:.o=.expect)
ALL_TESTS=run$(EXAMPLE) run$(TEST1)

ifeq ($(SUPPORTS_SHARED_LIBRARIES), true)
LDFLAGS=$(GALAX_ALL_CAPI_OPTSHAREDLIBS)
else
LDFLAGS=$(GALAX_ALL_CAPI_OPTLIBS)
endif

#########################################################################
# Section:  Main targets
# Description:
#     This is where all of the named toplevel targets are placed.
#
#  all:        This target builds the ALL_PROGRAMS
#  install::   This target does installation for C API example files
#  uninstall:: This target uninstalls C API example files
#  clean::     This target cleans files created in the all section
#########################################################################

all:

#all: $(ALL_PROGRAMS)

byte:

tests:	$(ALL_TESTS)

install: $(CONF_GALAX_EXAMPLES)/c_api
	for i in $(ALL_SOURCE) $(ALL_EXPECT); do ($(CP) $$i $(CONF_GALAX_EXAMPLES)/c_api); done
	$(SED) -e "s:CONF_GALAX_CONFIG:$(CONF_GALAX_CONFIG):g" Makefile-inst > $(CONF_GALAX_EXAMPLES)/c_api/Makefile

uninstall:
	for i in $(ALL_SOURCE) $(ALL_EXPECT); do ($(RM) $(CONF_GALAX_EXAMPLES)/c_api/$$i); done
	$(RM) $(CONF_GALAX_EXAMPLES)/c_api/Makefile

clean:
	$(RM) $(ALL_PROGRAMS)
	$(RM) *.cm[oixa] *.[oa] *.class *~
	$(RM) to_html.xml
	$(RM) *.xml *.cmp

clobber::

#########################################################################
# Sub-Section:  Secondary targets
# Description:
#     These are the supporting targets for "all"
#########################################################################

$(CONF_GALAX_EXAMPLES)/c_api:
	$(MKDIR) $(CONF_GALAX_EXAMPLES)/c_api

$(EXAMPLE)$(EXE): $(EXAMPLEOBJECT)
	$(CC) $(EXAMPLEOBJECT) $(LDFLAGS) -o $@

$(TEST1)$(EXE): $(TEST1OBJECT)
	$(CC) $(TEST1OBJECT) $(LDFLAGS) -g -o $@

#########################################################################
# Sub-Section:  Secondary targets
# Description:
#     These are the supporting targets for "tests"
#########################################################################

run$(EXAMPLE): $(EXAMPLE).out $(EXAMPLE).expect
	if [[ -z "`cmp $(EXAMPLE).out $(EXAMPLE).expect`" ]]; then echo "$(EXAMPLE) passed"; else $(MAKE) TEST=$(EXAMPLE) error; fi;

$(EXAMPLE).out:	$(EXAMPLE)$(EXE)
	./$(EXAMPLE)$(EXE) > $@

run$(TEST1): $(TEST1).out $(TEST1).expect
	if [[ -z "`cmp $(TEST1).out $(TEST1).expect`" ]]; then echo "$(TEST1) passed"; else $(MAKE) TEST=$(TEST1) error; fi;

$(TEST1).out:	$(TEST1)$(EXE)
	./$(TEST1)$(EXE) > $@

#########################################################################
# Section:  Makefile post-includes
# Description:
#		There are currently no post-includes for this Makefile
#########################################################################

=== examples/caml_api/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.35 2007/05/16 15:32:10 mff Exp $ #

#########################################################################
# Author:	Christopher A. Rath (AT&T Labs Research)
# Descripton:
#		This is a replacement Makefile for the Galax OCaml API examples.
# History:
#	$Log: Makefile,v $
#	Revision 1.35  2007/05/16 15:32:10  mff
#	
#	
#	May 16, 2007 - Mary
#	
#	  MODULES and INTERFACES
#	  *** PLEASE READ THE WHOLE MESSAGE ***
#	
#	  o Deep changes to support separate module interfaces and module
#	    implementations.
#	
#	    - Compilation/evaluation now occur within context of a "compiled
#	      program".  (In new module code_selection/Compiled_program_units)
#	
#	      A compiled program consists of imported module interfaces,
#	      imported library modules, and an optional main module.
#	
#	    - All program units (statements,prologs,modules) are compiled in
#	      context of a compiled_program unit.
#	
#	    - New pre-processing phase (before normalization), computes
#	      transitive closure of imported library modules.  Used to
#	      populate compiled_program unit.
#	
#	    - Recursive module imports (as per standard) are prohibited.
#	
#	   o Changes to ASTs:
#	
#	     We distinguish between "external" functions/vars (which are
#	     defined in external programming environment) from "imported"
#	     functions/vars (which are defined in imported XQuery modules)
#	
#	     New kinds of declarations:
#	     Xquery_ast : EFunctionInterface and EVarInterface
#	     Xquery_core_ast : CEFunctionInterface and CEVarInterface
#	     Xquery_algebra_ast : AOEFunctionInterface and AOEVarDeclInterface
#	
#	   o Importing interfaces and modules
#	
#	     Module interfaces are imported during normalization.  Variable
#	     and function declarations in the Core rep of the imported
#	     interface are merged into the Core rep of the importing module.
#	
#	     If a module does not have an interface, an interface is created
#	     for it during the pre-processing stage.
#	
#	   o New interface stdlib/pervasive.xqi replaces stdlib/pervasive.xq
#	
#	     - Removed stdlib/pervasive.xq
#	     - NB: new file suffix ".xqi" for module interfaces.
#	
#	   o Code selection
#	
#	     References to imported variables and functions are resolved
#	     during code selection of the importing module.
#	
#	     The code_selection_context for a module points to the
#	     code_selection_contexts of the modules that it imports to resolve
#	     references to imported variables/functions.
#	
#	   o What works:
#	
#	     - Usecase, XQuery testsuite, and Galax regressions all pass
#	
#	   o What doesn't work:
#	
#	     - examples/caml_api/test.ml
#	     - C or Java APIs
#	     - Any DXQ program
#	
#	   o TODO:
#	
#	     - Physical types for external and imported variables: Right now,
#	     they are completely materialized XML values.
#	
#	Revision 1.34  2007/02/01 22:08:46  simeon
#	February 1, 2007 - Jerome
#	
#	  o Code cleanup:
#	     - Cleaned up all the source file headers. Added module
#	       descriptions when missing, as well as CVS Id.
#	     - Removed obsolete modules: Optimization_rules_treepattern_old,
#	       Factorize_sideeffects.
#	
#	  o AST Walker:
#	     - Added support for a generic fold operation on the AST (useful
#	       to compute a boolean property on the AST for instance).
#	
#	  o Normalization:
#	     - Small fix to the normalization of comparisons to re-enable join
#	       detection, not using let bindings for the comparator
#	       anymore. [hack]
#	
#	  o Rewriting:
#	     - Added a judgment to check for side-effects, removed
#	       corresponding obsolete judgment in Factorization.
#	     - Moved the snap removal rule from optimization to rewriting,
#	       cleaning up the plans as early as possible.
#	
#	Revision 1.33  2006/05/15 15:20:36  car
#	May 15, 2006 - Chris Rath
#	  o Added a new target, "byte" to the toplevel and subordinate Makefiles.
#	    - Only creates the byte-code galax library and byte-code toplevel applications.
#	  o Added a new target "byteworld" that works like "make world"
#		 - Only creates the byte-code galax library and byte-code toplevel applications.
#	
#	Revision 1.32  2006/05/12 18:15:00  car
#	May 12, 2006 - Chris Rath
#	  o Fixed missing files and typos in Makefile.galax
#	  o Added "regression" target to top level Makefile.
#	  o Removed regress/testconfig.xml from CVS; this file is now generated from testconfig-tmpl.xml
#	  o Updated all lower-level Makefiles to ensure they all have the standard targets
#	
#	Revision 1.31  2006/04/17 18:10:40  car
#	April 17, 2006 - Chris Rath
#	  o Changes necessary to align with GODI
#	
#########################################################################

#########################################################################
# Section:	Default target
# Description:
#		The default target for this Makefile is "all"
#########################################################################
default:	all

#########################################################################
# Section:	Makefile pre-includes
# Description:
#		This is where the file(s) generated during by the Configure script
#		are included.  If config/Makefile.conf does not exist, the
#		make will fail.
#
#		Makefile.galax:	Variables defined for compiling and linking Galax
#								applications in the build environment
#########################################################################
LOCALPREFIX=../..

include $(LOCALPREFIX)/config/Makefile.galax

#########################################################################
# Sub-Section:	Targets
# Description:
#		These are the configuration-dependent targets built by "all"
###########################################################################
BYTETARGETS=\
example$(BYTE) \
test$(BYTE)

OPTTARGETS=\
example$(OPT) \
test$(OPT)

TESTS=runexample runtest

TARGETS=$(BYTETARGETS)
ifdef OCAMLOPT
TARGETS+=$(OPTTARGETS)
TESTS+=runoptexample runopttest
endif

#########################################################################
# Section:  Main targets
# Description:
#     This is where all of the named toplevel targets are placed.
#
#  all:        This target builds the TARGETS (temporarily disabled)
#  install::   This target does installation for OCaml API example files
#  uninstall:: This target uninstalls OCaml API example files
#  clean::     This target cleans files created in the all section
#########################################################################

all: $(TARGETS)

byte:	$(BYTETARGETS)

tests:	$(TESTS)

install: $(CONF_GALAX_EXAMPLES)/caml_api
	$(SED) -e "s:CONF_GALAX_CONFIG:$(CONF_GALAX_CONFIG):g" Makefile-inst > $(CONF_GALAX_EXAMPLES)/caml_api/Makefile
	$(CP) example.ml $(CONF_GALAX_EXAMPLES)/caml_api
	$(CP) example.expect $(CONF_GALAX_EXAMPLES)/caml_api
	$(CP) test.ml $(CONF_GALAX_EXAMPLES)/caml_api
	$(CP) test.expect $(CONF_GALAX_EXAMPLES)/caml_api

uninstall:
	$(RM) $(CONF_GALAX_EXAMPLES)/caml_api/Makefile
	$(RM) $(CONF_GALAX_EXAMPLES)/caml_api/example.ml
	$(RM) $(CONF_GALAX_EXAMPLES)/caml_api/example.expect
	$(RM) $(CONF_GALAX_EXAMPLES)/caml_api/test.ml
	$(RM) $(CONF_GALAX_EXAMPLES)/caml_api/test.expect

clean:
	$(RM) $(TARGETS)
	$(RM) *.cmx *.cmo *.o

clobber::

#########################################################################
# Sub-Section:  Secondary targets
# Description:
#     These are the supporting targets for "all"
#########################################################################

$(CONF_GALAX_EXAMPLES)/caml_api:
	$(MKDIR) $(CONF_GALAX_EXAMPLES)/caml_api

example$(BYTE):	example.cmo
	$(OCAMLC) -custom -linkall $(OCAMLC_FLAGS) -o $@ $(GALAX_ALL_INCLUDES) $(GALAX_ALL_LIBS) example.cmo

example$(OPT):	example.cmx
	$(OCAMLOPT) -linkall $(OCAMLOPT_FLAGS) -o $@ $(GALAX_ALL_INCLUDES) $(GALAX_ALL_OPTLIBS) example.cmx

test$(BYTE):	test.cmo
	$(OCAMLC) -custom -linkall $(OCAMLC_FLAGS) -o $@ $(GALAX_ALL_INCLUDES) $(GALAX_ALL_LIBS) test.cmo

test$(OPT):	test.cmx
	$(OCAMLOPT) -linkall $(OCAMLOPT_FLAGS) -o $@ $(GALAX_ALL_INCLUDES) $(GALAX_ALL_OPTLIBS) test.cmx

runexample:	example$(BYTE)
	$(RM) example.out
	./example$(BYTE) > example.out
	if [[ -z "`cmp example.out example.expect`" ]]; then echo "examples/caml_api/example$(BYTE) passed"; else $(MAKE) TEST=example$(BYTE) error; fi;

runtest:	test$(BYTE)
	$(RM) test.out
	./test$(BYTE) > test.out
	if [[ -z "`cmp test.out test.expect`" ]]; then echo "tests/caml_api/test$(BYTE) passed"; else $(MAKE) TEST=test$(BYTE) error; fi;

runoptexample:	example$(OPT)
	$(RM) optexample.out
	./example$(OPT) > optexample.out
	if [[ -z "`cmp optexample.out example.expect`" ]]; then echo "examples/caml_api/example$(OPT) passed"; else $(MAKE) TEST=example$(OPT) error; fi;

runopttest:	test$(OPT)
	$(RM) opttest.out
	./test$(OPT) > opttest.out
	if [[ -z "`cmp opttest.out test.expect`" ]]; then echo "tests/caml_api/test$(OPT) passed"; else $(MAKE) TEST=test$(OPT) error; fi;

#########################################################################
# Section:  Makefile post-includes
# Description:
#		There are currenlty no post-includes for this Makefile
#########################################################################

=== examples/docs/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.2 2007/02/01 22:08:46 simeon Exp $ #

#########################################################################
# Author:	Christopher A. Rath (AT&T Labs Research)
# Descripton:
#		This is a replacement Makefile for the Galax example documents
# History:
#	$Log: Makefile,v $
#	Revision 1.2  2007/02/01 22:08:46  simeon
#	February 1, 2007 - Jerome
#	
#	  o Code cleanup:
#	     - Cleaned up all the source file headers. Added module
#	       descriptions when missing, as well as CVS Id.
#	     - Removed obsolete modules: Optimization_rules_treepattern_old,
#	       Factorize_sideeffects.
#	
#	  o AST Walker:
#	     - Added support for a generic fold operation on the AST (useful
#	       to compute a boolean property on the AST for instance).
#	
#	  o Normalization:
#	     - Small fix to the normalization of comparisons to re-enable join
#	       detection, not using let bindings for the comparator
#	       anymore. [hack]
#	
#	  o Rewriting:
#	     - Added a judgment to check for side-effects, removed
#	       corresponding obsolete judgment in Factorization.
#	     - Moved the snap removal rule from optimization to rewriting,
#	       cleaning up the plans as early as possible.
#	
#	Revision 1.1  2006/05/17 15:15:05  car
#	May 17, 2006 Chris Rath
#	 o Added Makefile for examples/docs
#	
#########################################################################

#########################################################################
# Section:	Default target
# Description:
#		The default target for this Makefile is "all"
#########################################################################

default:	all

#########################################################################
# Section:	Makefile pre-includes
# Description:
#		This is where the file(s) generated during by the Configure script
#		are included.  If config/Makefile.conf does not exist, the
#		make will fail.
#
#		Makefile.galax:	Variables defined for compiling and linking Galax
#								applications in the build environment
#########################################################################
LOCALPREFIX=../..
include $(LOCALPREFIX)/config/Makefile.galax

#########################################################################
# Section:	Local variables
# Description:
#		These variables are used for targets of this Makefile
###########################################################################
_DOCFILES=\
hispo.xml \
hispo.xsd \
htmlpath.xq \
report.xml \
seq.xq \
seq_context.xq \
to_html.xml \
xml-example.xml \
xmlschema_context.xq \
xq-example1.xq \
xq-example2.xq

#########################################################################
# Section:  Main targets
# Description:
#     This is where all of the named toplevel targets are placed.
#
#  all:        This target builds the GALAX_CAPI_TARGETS
#  install::   This target does installation for C API files
#  uninstall:: This target uninstalls C API files
#  clean::     This target cleans files created in the all section
#########################################################################
all:

byte:

install: $(CONF_GALAX_EXAMPLES)/docs
	for i in $(_DOCFILES); do ($(CP) $$i $(CONF_GALAX_EXAMPLES)/docs); done

uninstall:
	for i in $(_DOCFILES); do ($(RM) $(CONF_GALAX_EXAMPLES)/docs/$$i); done

clean:

clobber::

#########################################################################
# Sub-Section:  Secondary targets
# Description:
#     These are the supporting targets for "all"
#########################################################################

$(CONF_GALAX_EXAMPLES)/docs:
	$(MKDIR) $(CONF_GALAX_EXAMPLES)/docs

#########################################################################
# Section:  Makefile post-includes
# Description:
#		There are currently no post-includes for this Makefile
#########################################################################

=== examples/java_api/Makefile ===
#########################################################################
#                                                                       #
#                                  GALAX                                #
#                               XQuery Engine                           #
#                                                                       #
#   Copyright 2001-2007.                                                #
#   Distributed only by permission.                                     #
#                                                                       #
#########################################################################

#########################################################################
# Author:	Christopher A. Rath (AT&T Labs Research)
# Descripton:
#		This is a replacement Makefile for the Galax Java API examples
# History:
#	$Log: Makefile,v $
#	Revision 1.38  2007/12/06 02:19:14  mff
#	
#	December 5, 2007 - Mary
#	
#	  o Java API
#	    - Changes to get Java API to link
#	
#	    TODO: align examples/galapi/java_api
#	
#	Revision 1.37  2007/02/01 22:08:46  simeon
#	February 1, 2007 - Jerome
#	
#	  o Code cleanup:
#	     - Cleaned up all the source file headers. Added module
#	       descriptions when missing, as well as CVS Id.
#	     - Removed obsolete modules: Optimization_rules_treepattern_old,
#	       Factorize_sideeffects.
#	
#	  o AST Walker:
#	     - Added support for a generic fold operation on the AST (useful
#	       to compute a boolean property on the AST for instance).
#	
#	  o Normalization:
#	     - Small fix to the normalization of comparisons to re-enable join
#	       detection, not using let bindings for the comparator
#	       anymore. [hack]
#	
#	  o Rewriting:
#	     - Added a judgment to check for side-effects, removed
#	       corresponding obsolete judgment in Factorization.
#	     - Moved the snap removal rule from optimization to rewriting,
#	       cleaning up the plans as early as possible.
#	
#	Revision 1.36  2006/05/17 15:27:39  mff
#	May 17, 2006 - Mary
#	
#	  o Browser interface/Website
#	    - Updated to align w/ GODI configuration & Galax 0.6.5.
#	    - Fixed CGI printing bug.  All output now printed correctly.
#	
#	  o Documentation
#	    - Updating documentation for GODI release.
#	
#	  o Logical Plan Printing
#	    - Fixed old bug that replicated algebra: namespace.
#	
#	  o Loading
#	    - Made interface names more mneumonic
#	
#	  o Java API & Examples Makefiles
#	    - Added path to CAPI libraries
#	    - Fix to install: target
#	
#	  TODO: Document command-line options :=(
#	
#	Revision 1.35  2006/05/15 15:20:36  car
#	May 15, 2006 - Chris Rath
#	  o Added a new target, "byte" to the toplevel and subordinate Makefiles.
#	    - Only creates the byte-code galax library and byte-code toplevel applications.
#	  o Added a new target "byteworld" that works like "make world"
#		 - Only creates the byte-code galax library and byte-code toplevel applications.
#	
#	Revision 1.34  2006/05/12 18:15:00  car
#	May 12, 2006 - Chris Rath
#	  o Fixed missing files and typos in Makefile.galax
#	  o Added "regression" target to top level Makefile.
#	  o Removed regress/testconfig.xml from CVS; this file is now generated from testconfig-tmpl.xml
#	  o Updated all lower-level Makefiles to ensure they all have the standard targets
#	
#	Revision 1.33  2006/04/17 18:10:40  car
#	April 17, 2006 - Chris Rath
#	  o Changes necessary to align with GODI
#	
#########################################################################

#########################################################################
# Section:	Default target
# Description:
#		The default target for this Makefile is "all"
#########################################################################

default:	all

#########################################################################
# Section:	Makefile pre-includes
# Description:
#		This is where the file(s) generated during by the Configure script
#		are included.  If config/Makefile.conf does not exist, the
#		make will fail.
#
#		Makefile.galax:	Variables defined for compiling and linking Galax
#								applications in the build environment
#########################################################################
LOCALPREFIX=../..

include $(LOCALPREFIX)/config/Makefile.galax

#########################################################################
# Section:	Local variables
# Description:
#		These variables are used for targets of this Makefile
###########################################################################

EXAMPLE=example
TEST=test

JAVACLASSPATH=-classpath .:$(LOCALPREFIX)/galapi/java_api/$(GALAX_JAVAAPI_ARCHIVE)
API=java_api

EXFILES=\
Example.java \
Test.java \
example.expect \
test.expect

#########################################################################
# Sub-Section:	Targets
# Description:
#		These are the configuration-dependent targets built by "all"
###########################################################################
ALL_PROGRAMS=runexample runtest

#########################################################################
# Section:  Main targets
# Description:
#     This is where all of the named toplevel targets are placed.
#
#  all:        This target builds the GALAX_CAPI_TARGETS
#  install::   This target does installation for C API files
#  uninstall:: This target uninstalls C API files
#  clean::     This target cleans files created in the all section
#########################################################################

tests:	$(ALL_PROGRAMS)

all:	$(ALL_PROGRAMS)

byte:

install:	$(CONF_GALAX_EXAMPLES)/java_api
	for i in $(EXFILES); do ($(CP) $$i $(CONF_GALAX_EXAMPLES)/java_api); done
	$(SED) -e "s:CONF_GALAX_CONFIG:$(CONF_GALAX_CONFIG):g" Makefile-inst > $(CONF_GALAX_EXAMPLES)/java_api/Makefile

uninstall:
	for i in $(EXFILES); do ($(RM) $(CONF_GALAX_EXAMPLES)/java_api/$$i); done
	$(RM) $(CONF_GALAX_EXAMPLES)/java_api/Makefile

clean:
	$(RM) Example.class Test.class example.xml test.xml

clobber::

#########################################################################
# Sub-Section:  Secondary targets
# Description:
#     These are the supporting targets for "all"
#########################################################################

runexample: Example.class
	(export $(LD_LIBRARY_PATH_VAR)=$(LD_LIBRARY_PATH):$(LOCALPREFIX)/galapi/c_api:$(LOCALPREFIX)/galapi/java_api:$(CONF_C_LIBPCRE):$(CONF_C_LIBBDB); \
        $(JAVA) -classpath .:$(LOCALPREFIX)/galapi/java_api/galapi.jar Example >$(EXAMPLE).out; )
	if [[ -z "`cmp $(EXAMPLE).out $(EXAMPLE).expect`" ]]; then echo "$(EXAMPLE) passed"; else $(MAKE) TEST=$(EXAMPLE) error; fi;

runtest: Test.class 
	(export $(LD_LIBRARY_PATH_VAR)=$(LD_LIBRARY_PATH):$(LOCALPREFIX)/galapi/c_api:$(LOCALPREFIX)/galapi/java_api:$(CONF_C_LIBPCRE):$(CONF_C_LIBBDB); \
	$(JAVA) $(JAVACLASSPATH) Test >$(TEST).out)
	if [[ -z "`cmp $(TEST).out $(TEST).expect`" ]]; then echo "$(TEST) passed"; else $(MAKE) TEST=$(TEST) error; fi;

$(CONF_GALAX_EXAMPLES)/java_api:
	$(MKDIR) $@

#########################################################################
# Section:  Makefile post-includes
# Description:
#		There are currently no post-includes for this Makefile
#########################################################################

=== debian/changelog ===
galax (1.1-13build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 12:46:05 +0000

galax (1.1-13) unstable; urgency=medium

  * Port to ocamlnet 4.0.4

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 17 Oct 2015 00:35:38 +0200

galax (1.1-12) unstable; urgency=medium

  * Team upload.
  * Fix space/tab issues in some Makefiles.
  * Generate a dummy Makefile.conf so that "make clean" doesn't fail.
    (Closes: #750316).

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 09 Aug 2014 14:29:25 +0200

galax (1.1-11) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload

  [ Andreas Moog ]
  * Apply patch from upstream git to fix build with OCaml 4.01
    (Closes: #731398)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 01 Feb 2014 20:07:36 +0100

galax (1.1-10) unstable; urgency=low

  * Team upload
  * Fix configure on hurd (Closes: #647765)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 11 Nov 2011 00:42:50 +0100

galax (1.1-9) unstable; urgency=low

  * Team upload
  * Fix build with camomile 0.8.3 (Closes: #636025)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 12 Aug 2011 08:15:53 +0200

galax (1.1-8) unstable; urgency=low

  * Team upload
  * Remove myself from Uploaders
  * Fix build with ocamlnet 3.3.5
  * Bump Standards-Version to 3.9.2
  * Bump debhelper compatibility level to 8

 -- Stéphane Glondu <glondu@debian.org>  Sat, 23 Jul 2011 23:37:45 +0200

galax (1.1-7) unstable; urgency=low

  * debian/control:
    - add myself to Uploaders and remove Stefano
    - update Homepage
    - bump Standards-Version to 3.8.4 (no changes)
  * debian/patches:
    - replace 0002-bump-expected-OCaml-version-to-3.11.patch by
      0002-Make-OCaml-version-requirement-a-lower-bound.patch
    - add 0005-Fix-some-typos.patch
  * Use up-to-date config.{sub,guess}
  * Switch source package format to 3.0 (quilt)
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Tue, 18 May 2010 22:51:23 +0200

galax (1.1-6) unstable; urgency=low

  * rm debian/svn-deblayout: obsolete, we are now using Git
  * debian/control
    - bump Standards-Version to 3.8.3 (no changes needed)
    - bump build-dep on dh-ocaml to 0.9, as we now use dh_ocaml*
    - add ${ocaml:Depends/Provides} since now we use dh_ocaml; keep
      hand-written deps on libraries for the interim
  * debian/rules
    - switch to dh_ocamldoc for API reference generation, stop relying on
      ocamldoc-api-ref-config, which is gone (Closes: #549850)
    - switch to dh 7
  * debian/patches:
    - port from dpatch to quilt (for dh 7 compatibility)
    - new patch 0004-fix-syntax-errors-in-ocamldoc-tags: fix some ocamldoc
      markup errors (overlooked thus far)

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 07 Oct 2009 09:17:20 +0200

galax (1.1-5) unstable; urgency=low

  * rebuild against OCaml 3.11, bump build-dependencies accordingly
  * bump debhelper compatibility level to 7
  * debian/control
    - add build-dependency on dh-ocaml, which ships the CDBS class
    - make consistent the indentation of dependency fields
    - bump Standards-Version to 3.8.1 (no changes needed)
    - add strict build-deps to induce dep-waits during the transition
    - set maintainer to d-o-m, myself as an uploader
    - add missing ${misc:Depends} to galax-doc deps
    - move the library to archive section "ocaml"
  * debian/rules
    - invoke ocamldoc-api-ref-config from /usr/share/ocaml (moved there)
    - use ocaml.mk class as a "rules" file, as now is
  * debian/patches/
    - new patch build-ocaml-3.11, bump expected OCaml version to 3.11
    - new patch build-pxp-1.2, forward port code to build against PXP 1.2
  * debian/copyright: reference GPL-3 common license file

 -- Stefano Zacchiroli <zack@debian.org>  Thu, 19 Mar 2009 11:44:26 +0100

galax (1.1-4) unstable; urgency=medium

  * bump Standards-Version to 3.8.0 (no changes needed)
  * debian/control
    - add missing dependency on libcamomile-ocaml-data (Closes: #487482)
    - reformat dependency fields to be on multiple lines (as it is more
      diff-friendly)
    - update Vcs-* fields to the new git repository
  * add debian/watch file (though it won't be able to download upstream
    tarball, as it is "protected" by a form; at least the check for new
    releases works ...)

 -- Stefano Zacchiroli <zack@debian.org>  Sat, 19 Jul 2008 21:52:00 +0200

galax (1.1-3) unstable; urgency=low

  * debian/rules: remove .depend files created during clean, as they cause
    FTBFSs (permission denied) on buildds using -rsudo (Closes: #483940)

 -- Stefano Zacchiroli <zack@debian.org>  Thu, 05 Jun 2008 10:48:40 +0200

galax (1.1-2) unstable; urgency=low

  [ Ralf Treinen ]
  * Changed doc-base section (of the Galax manual) to Programming

  [ Stefano Zacchiroli ]
  * rebuild the galax-doc package against latest ocaml.mk CDBS class, so that
    the doc-base section (of the Galax API reference) gets moved to doc-base
    section Programming/OCaml

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 04 Jun 2008 13:52:30 +0200

galax (1.1-1) unstable; urgency=low

  * new upstream release: 1.1 (first public release of the 1.x series)
  * debian/patches/
    - add patch missing-BUGS-doc.dpatch to fix a LaTeX compilation error, due
      to a (now) missing BUGS document in the toplevel dir
  * refresh debian/docs to point to the current documentation

 -- Stefano Zacchiroli <zack@debian.org>  Wed, 26 Mar 2008 16:17:34 +0100

galax (1.0~rc1-1) experimental; urgency=low

  * new upstream release: 1.0 release candidate
  * debian/patches/
    - remove patches: build-wo-ocamlopt, configure_typo, latex-inputenc, meta;
      all have been integrated upstream
  * better sections for binary packages, following the conventions of other
    XML-related packages (default is now "text", galaxd in "net")
  * add missing build-depend on camlp4 (for camlp4o)
  * add missing build-depend on texlive-latex-extra (for comment.sty)



=== debian/control ===
Source: galax
Section: text
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Build-Depends:
 debhelper (>= 8),
 dh-ocaml (>= 0.9~),
 ocaml-nox (>= 3.11.1-3~),
 autotools-dev,
 camlp4,
 libpcre-ocaml-dev,
 libocamlnet-ocaml-dev (>= 4.0.4),
 libpxp-ocaml-dev (>= 1.2.1-1~),
 libcamomile-ocaml-dev,
 hevea,
 texlive-latex-base,
 texlive-latex-extra
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/galax.git
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/galax.git
Homepage: http://galax.sourceforge.net/

Package: galax
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libcamomile-ocaml-data
Description: XQuery implementation with static typing - command line front-ends
 Galax is an implementation of XQuery, the W3C XML Query Language.
 .
 Galax implements XQuery 1.0 as specified by the W3C, as well as XPath 2.0,
 which is subset of XQuery 1.0.
 .
 Galax is a Schema-aware implementation of XQuery and supports static
 typing. Also thanks to that, Galax is a really fast implementation of the
 language.
 .
 Galax supports some advanced XQuery features, such as XML Schema validation,
 XML updates, XQuery optimization and projection, applications of XQuery to Web
 services.
 .
 This package contains the command line front-ends to evaluate XQuery queries
 and to validate XML documents against XML Schemas.

Package: galax-extra
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libcamomile-ocaml-data
Recommends: galax
Description: XQuery implementation with static typing - utilities
 Galax is an implementation of XQuery, the W3C XML Query Language.
 .
 Galax implements XQuery 1.0 as specified by the W3C, as well as XPath 2.0,
 which is subset of XQuery 1.0.
 .
 Galax is a Schema-aware implementation of XQuery and supports static
 typing. Also thanks to that, Galax is a really fast implementation of the
 language.
 .
 Galax supports some advanced XQuery features, such as XML Schema validation,
 XML updates, XQuery optimization and projection, applications of XQuery to Web
 services.
 .
 This package contains several command line utilities which complete the
 front-ends provided by the galax package. Utilities are provided to validate
 XML Schemas and WSDL, inspect query execution plans, and convert queries among
 alternative syntaxes (plain text and XQueryX).

Package: galaxd
Section: net
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ${ocaml:Depends},
 libcamomile-ocaml-data
Suggests: galax
Description: XQuery implementation with static typing - network servers
 Galax is an implementation of XQuery, the W3C XML Query Language.
 .
 Galax implements XQuery 1.0 as specified by the W3C, as well as XPath 2.0,
 which is subset of XQuery 1.0.
 .
 Galax is a Schema-aware implementation of XQuery and supports static
 typing. Also thanks to that, Galax is a really fast implementation of the
 language.
 .
 Galax supports some advanced XQuery features, such as XML Schema validation,
 XML updates, XQuery optimization and projection, applications of XQuery to Web
 services.
 .
 This package contains galaxd, the Galax network server which executes query
 plans issued by remote clients. Extra helpers for remote execution (zerod and
 webgui) are also provided by this package.

Package: libgalax-ocaml-dev
Section: ocaml
Architecture: any
Depends:
 libpcre-ocaml-dev,
 libocamlnet-ocaml-dev,
 libpxp-ocaml-dev,
 libcamomile-ocaml-dev,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Suggests: ocaml-findlib
Description: XQuery implementation with static typing - OCaml libraries
 Galax is an implementation of XQuery, the W3C XML Query Language.
 .
 Galax implements XQuery 1.0 as specified by the W3C, as well as XPath 2.0,
 which is subset of XQuery 1.0.
 .
 Galax is a Schema-aware implementation of XQuery and supports static
 typing. Also thanks to that, Galax is a really fast implementation of the
 language.
 .
 Galax supports some advanced XQuery features, such as XML Schema validation,
 XML updates, XQuery optimization and projection, applications of XQuery to Web
 services.
 .
 This package contains the OCaml development libraries to use Galax, as a
 library, in your OCaml applications.

Package: galax-doc
Section: doc
Architecture: all
Suggests:
 galax,
 libgalax-ocaml-dev
Depends: ${misc:Depends}
Description: XQuery implementation with static typing - documentation
 Galax is an implementation of XQuery, the W3C XML Query Language.
 .
 Galax implements XQuery 1.0 as specified by the W3C, as well as XPath 2.0,
 which is subset of XQuery 1.0.
 .
 Galax is a Schema-aware implementation of XQuery and supports static
 typing. Also thanks to that, Galax is a really fast implementation of the
 language.
 .
 Galax supports some advanced XQuery features, such as XML Schema validation,
 XML updates, XQuery optimization and projection, applications of XQuery to Web
 services.
 .
 This package contains the Galax documentation. User's and reference manuals
 are provided, as well as the OCaml API reference for the Galax library.

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

override_dh_auto_configure:
	if [ ! -d doc.backup ]; then cp -a doc doc.backup; fi
	touch config/Makefile.conf
	$(MAKE) clean
	rm config/Makefile.conf
	for ext in sub guess; do \
	  if [ -f /usr/share/misc/config.$$ext ] && \
	    ! [ -f debian/config.orig.$$ext ]; then \
	    mv config/config.$$ext debian/config.orig.$$ext; \
	    cp -f /usr/share/misc/config.$$ext config/config.$$ext; \
	  fi; \
	done
	./configure -galax-camllib $(OCAML_STDLIB_DIR)/galax			\
		-galax-camllib $(OCAML_STDLIB_DIR)/galax -galax-home /usr	\
		-galax-lib /usr/lib/galax -galax-man /usr/share/man		\
		-galax-usecases /usr/share/doc/galax/usecases			\
		-galax-regress /usr/share/doc/galax/regress			\
		-galax-examples /usr/share/doc/galax/examples			\
		-galax-config /usr/share/doc/galax/config -with-galaxd
	sed -i 's:^\(CONF_GALAX_\w\+\)=/:\1=$$(DESTDIR)/:' config/Makefile.conf

override_dh_auto_build:
	$(MAKE) world
	$(MAKE) -C doc/ manual.pdf manual.html

# remove .depend created during clean as they cause FTBFSs with -rsudo
override_dh_auto_clean:
	if [ -d doc -a ! -d doc.backup ]; then mv doc doc.backup; fi
	rm -Rf doc
	touch config/Makefile.conf
	$(MAKE) clean
	rm config/Makefile.conf
	if [ -d doc.backup ]; then mv doc.backup doc; fi
	for ext in sub guess; do \
	  if [ -f debian/config.orig.$$ext ] ; then \
	    mv -f debian/config.orig.$$ext config/config.$$ext; \
	  fi; \
	done

override_dh_auto_install:
	# $(LN) override so that we only install the best binary, instead of
	# both .opt and .byte together with the best symlink
	$(MAKE) install LN=cp DESTDIR=$(CURDIR)/debian/tmp
	# fix wrong permissions (+x) on some .mli files
	chmod 644 debian/tmp$(OCAML_STDLIB_DIR)/galax/*.mli
	# avoid cluttering usr/bin with too generic names
	cp debian/tmp/usr/bin/zerod  debian/tmp/usr/bin/galax-zerod
	cp debian/tmp/usr/bin/webgui debian/tmp/usr/bin/galax-webgui

ifeq ($(OCAML_HAVE_OCAMLOPT),no)
override_dh_strip:
	dh_strip -Xusr/bin
endif

override_dh_install:
	dh_install -XCVS -Xlicense.tex
override_dh_compress:
	dh_compress -X.pdf

=== debian/watch ===
version=3
http://sf.net/galax/galax-([0-9\.]+)-src\.tar\.gz
